package com.gxwebsoft.cms.controller;

import com.gxwebsoft.cms.entity.DocsContent;
import com.gxwebsoft.cms.param.DocsContentParam;
import com.gxwebsoft.cms.service.DocsContentService;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.web.PageResult;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 文档内容记录表控制器
 *
 * @author 科技小王子
 * @since 2024-03-23 19:51:37
 */
@Api(tags = "文档内容")
@RestController
@RequestMapping("/api/cms/docs-content")
public class DocsContentController extends BaseController {
    @Resource
    private DocsContentService docsContentService;

    @ApiOperation("分页查询文档内容记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<DocsContent>> page(DocsContentParam param) {
        // 使用关联查询
        return success(docsContentService.pageRel(param));
    }

    @ApiOperation("查询全部文档内容记录表")
    @GetMapping()
    public ApiResult<List<DocsContent>> list(DocsContentParam param) {
        // 使用关联查询
        return success(docsContentService.listRel(param));
    }

    @ApiOperation("根据id查询文档内容记录表")
    @GetMapping("/{id}")
    public ApiResult<DocsContent> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(docsContentService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('cms:docs:save')")
    @ApiOperation("添加文档内容记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody DocsContent docsContent) {
        if (docsContentService.save(docsContent)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('cms:docs:update')")
    @ApiOperation("修改文档内容记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody DocsContent docsContent) {
        if (docsContentService.updateById(docsContent)) {
            return success("保存成功");
        }
        return fail("保存失败");
    }

    @PreAuthorize("hasAuthority('cms:docs:remove')")
    @ApiOperation("删除文档内容记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (docsContentService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('cms:docs:update')")
    @ApiOperation("批量添加文档内容记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<DocsContent> list) {
        if (docsContentService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('cms:docs:update')")
    @ApiOperation("批量修改文档内容记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<DocsContent> batchParam) {
        if (batchParam.update(docsContentService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('cms:docs:remove')")
    @ApiOperation("批量删除文档内容记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (docsContentService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
